# FIS

Welcome to your new gem! In this directory, you'll find the files you need to be able to package up your Ruby library into a gem. Put your Ruby code in the file `lib/fis`. To experiment with that code, run `bin/console` for an interactive prompt.

TODO: Delete this and the text above, and describe your gem

## Installation

Add this line to your application's Gemfile:

```ruby
gem 'fis'
```

And then execute:

    $ bundle install

Or install it yourself as:

    $ gem install fis

## Usage

TODO: Write usage instructions here

## Development

After checking out the repo, run `bin/setup` to install dependencies. Then, run `rake spec` to run the tests. You can also run `bin/console` for an interactive prompt that will allow you to experiment.

To install this gem onto your local machine, run `bundle exec rake install`. To release a new version, update the version number in `version.rb`, and then run `bundle exec rake release`, which will create a git tag for the version, push git commits and tags, and push the `.gem` file to [rubygems.org](https://rubygems.org).

## Contributing

Bug reports and pull requests are welcome on GitHub at https://github.com/[USERNAME]/fis. This project is intended to be a safe, welcoming space for collaboration, and contributors are expected to adhere to the [code of conduct](https://github.com/[USERNAME]/fis/blob/master/CODE_OF_CONDUCT.md).


## Code of Conduct

Everyone interacting in the FIS project's codebases, issue trackers, chat rooms and mailing lists is expected to follow the [code of conduct](https://github.com/[USERNAME]/fis/blob/master/CODE_OF_CONDUCT.md).

## Copyright

Copyright (c) 2020 Tom Milewski. See [MIT License](LICENSE.txt) for further details.


## ---------------------------------------------------------------------------------------------

## Commands

## OLD ##

- directory
- reset
- whoami
- hello
- lint
- open
- next
- status
- submit
- save
- test
- version


## NEW ##

- auth:login
- auth:logout
- auth:whoami
- profile:status
- config:directory
- lession:open
- lession:lint
- lession:submit
- lession:test
- lession:save
- lession:next

- auth
  - login
  - logout
  - whoami
- status
- config
  - directory
- lesson
  - open
  - lint
  - submit
  - test
  - save
  - next

## Existing Structure

### Base

CLI: `learn version`
Runs: `Learn::VERSION`

### learn-config (Status: Not Started)

Configure the Learn.co gem

- CLI: `learn directory`
- Runs: `learn-config --set-directory`

- CLI: `learn resest`
- Runs: `learn-config --reset`

- CLI: `learn whoami`
- Runs: `learn-config --whoami`

### learn-generate (Status: Not Started)

Generates labs for Learn.co based on a set of lab templates


### learn-hello (Status: Not Started)

Checks your connection to Learn.co

- CLI: `learn hello`
- Runs: `learn-hello`


### learn_linter (Status: Not Started)

can lint a directory for valid .learn, license files

- CLI: `learn lint`
- Runs:
```ruby
def lint(dir=nil, quiet=nil)
  if dir && !quiet
    exec("learn-lint #{dir}")
  elsif dir && quiet
    exec("learn-lint #{dir} #{quiet}")
  elsif !dir && quiet
    exec("learn-lint #{quiet}")
  else
    current_dir = Dir.pwd
    exec("learn-lint #{current_dir}")
  end
end
```


### learn-open (Status: Not Started)

Open Learn lessons locally

- CLI: `learn open`
- Runs:
```ruby
  lab_name = Learn::Lab::Parser.new(lab_name.join(' ')).parse!
  editor = options[:editor]
  clone_only = options[:"clone-only"]

  command = "learn-open #{lab_name} --editor=#{editor}"
  command << " --clone-only" if clone_only

  exec(command)
```

- CLI: `learn next`
- Runs:
```ruby
  editor = options[:editor]
  clone_only = options[:"clone-only"]

  command = "learn-open --next --editor=#{editor}"
  command << " --clone-only" if clone_only

  exec(command)
```


### learn-status (Status: Not Started)

Gets your current status from Learn.co

- CLI: `learn status`
- Runs: `learn-status`


### learn-submit (Status: Not Started)

Submit your lessons to Learn.co

- CLI: `learn submit`
- Runs: 
```ruby
commit_message = if options['team']
  Learn::TeamMembers::Parser.new(ARGV).execute
else
  options['message']
end

exec("learn-submit #{commit_message}")
```

- CLI: `learn save`
- Runs: `learn-submit --save-only`


### learn-test (Status: Not Started)

Runs RSpec, Karma, Mocha, and Python Pytest Test builds and pushes JSON output to Learn.

- CLI: `learn [test]`
- Runs: `learn-test #{opts.join(' ')}`
